package BPpath.mp3recorder;

import android.app.AlertDialog;
import android.app.Dialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.net.Uri;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.text.Html;
import android.text.InputType;
import android.view.Gravity;
import android.view.LayoutInflater;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.AdapterView.OnItemLongClickListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.EditText;
import android.widget.TextView;
import android.widget.Toast;
import java.io.File;
import java.lang.Runnable;
import java.util.ArrayList;
import java.util.Collections;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/*
 * BoilerPlate.java is free software: you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * R. Earle Harris (gnudroider@tuxfamily.org) (c) 2014
 * Original file Copyright (c) 2011-2012 Yuichi Hirano
 *
 */

public class BoilerPlate extends ListActivity {

	public PRAFileHandler fhandler = new PRAFileHandler(this);
	public RecMicToMp3 mRecMicToMp3 = null;
	public TextView title = null;
	public String newTrack = "";
    public String this_app_dir; 
	public boolean recording = false;
	public Map<String, String> dbs;
	public int topPos = 0;

	private void findViews() {
		title = (TextView) findViewById(R.id.title);
	}

	@Override
	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		prepSdcardAppDir();
		setContentView(R.layout.main);
		findViews();

		Intent intent = getIntent();
		String action = intent.getAction();
		String type = intent.getType();

		if (Intent.ACTION_SEND.equals(action) && type != null) {
			if ("text/plain".equals(type)) {
				final String incoming = intent.getStringExtra(Intent.EXTRA_TEXT);
				if (incoming != null){
					final Dialog dialog2 = new Dialog(BoilerPlate.this);
					dialog2.requestWindowFeature(Window.FEATURE_NO_TITLE);
					dialog2.setContentView(R.layout.alert_two);
					dialog2.setCanceledOnTouchOutside(false);
					TextView t = (TextView) dialog2.findViewById(R.id.dTitle);
					t.setText("Record "+incoming+".mp3?");
					TextView m = (TextView) dialog2.findViewById(R.id.dMessage);
					m.setText("Press RECORD to begin.");
					Button pos = (Button) dialog2.findViewById(R.id.dPos);
					pos.setText("RECORD");
					pos.setOnClickListener(new OnClickListener() {
							@Override
								public void onClick(View v) {
								fhandler.removeExt(this_app_dir+"/"+incoming+".mp3");
								recording = true;
								newTrack = incoming+".mp3";
								record(incoming+".mp3");
								mRecMicToMp3.start();
								dialog2.dismiss();
								onResume();
							}
						});
					
					Button neg = (Button) dialog2.findViewById(R.id.dNeg);
					neg.setText("Cancel");
					neg.setOnClickListener(new OnClickListener() {
							@Override
								public void onClick(View v) {
								dialog2.dismiss();
							}
						});
					
					dialog2.show();
				} 
			}

			new SimpleEula(this).show();
		}
	}
	

	@Override
	public void onResume() {
		super.onResume();

		final String[] list = buildList();
		setListAdapter(new ArrayAdapter<String>(this,
				R.layout.pra_list_item, list));

		EdgeEffectListView listView = (EdgeEffectListView) getListView();
		listView.setTextFilterEnabled(true);
		listView.setOnItemClickListener(new OnItemClickListener() {
			public void onItemClick(AdapterView<?> parent, View view,
					int position, long id) {
				topPos = position;
				final String result = ((TextView) view).getText().toString();
				final String fruit = dbs.get(result);
				if (fruit.matches("_new_")){
					if (recording){
						recording = false;
						if (mRecMicToMp3 != null){
							mRecMicToMp3.stop();
						}
						return;
					}
					final Dialog dialog = new Dialog(BoilerPlate.this);
					dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
					dialog.setContentView(R.layout.alert_two_edit);
					dialog.setCanceledOnTouchOutside(false);
					TextView t = (TextView) dialog.findViewById(R.id.dTitle);
					t.setText("Record New Track");
					TextView m = (TextView) dialog.findViewById(R.id.dMessage);
					m.setText("Enter just the name with no .mp3 extension.");
					final EditText e = (EditText) dialog.findViewById(R.id.dEdit);
					e.setInputType(InputType.TYPE_CLASS_TEXT);
					
					Button pos = (Button) dialog.findViewById(R.id.dPos);
					pos.setText("RECORD");
					pos.setOnClickListener(new OnClickListener() {
							@Override
								public void onClick(View v) {
								String input = e.getText().toString();   
								input = input.replace(".mp3","");
								recording = true;
								newTrack = input+".mp3";
								record(input+".mp3");
								mRecMicToMp3.start();
								dialog.dismiss();
								onResume();
							}
						});
					
					Button neg = (Button) dialog.findViewById(R.id.dNeg);
					neg.setText("Cancel");
					neg.setOnClickListener(new OnClickListener() {
							@Override
								public void onClick(View v) {
								dialog.dismiss();
							}
						});
					
					dialog.show();
				} else if (!recording){
					final Dialog dialog2 = new Dialog(BoilerPlate.this);
					dialog2.requestWindowFeature(Window.FEATURE_NO_TITLE);
					dialog2.setContentView(R.layout.alert_two);
					dialog2.setCanceledOnTouchOutside(false);
					TextView t = (TextView) dialog2.findViewById(R.id.dTitle);
					t.setText("Re-record "+result+"?");
					TextView m = (TextView) dialog2.findViewById(R.id.dMessage);
					m.setText("Press RECORD to begin.");
					Button pos = (Button) dialog2.findViewById(R.id.dPos);
					pos.setText("RECORD");
					pos.setOnClickListener(new OnClickListener() {
							@Override
								public void onClick(View v) {
								fhandler.removeExt(fruit);
								recording = true;
								newTrack = result;
								record(result);
								mRecMicToMp3.start();
								dialog2.dismiss();
								onResume();
							}
						});
					
					Button neg = (Button) dialog2.findViewById(R.id.dNeg);
					neg.setText("Cancel");
					neg.setOnClickListener(new OnClickListener() {
							@Override
								public void onClick(View v) {
								dialog2.dismiss();
							}
						});
					
					dialog2.show();
				} else {
					recording = false;
					if (mRecMicToMp3 != null){
						mRecMicToMp3.stop();
					}
					onResume();
				}
			}
		});

		final String[] menu_array = { 
			"Play", 
			"Rename", 
			"Delete", 
			"ID3 Tag", 
			"Upload", 
		};

		final Context c = this;

		listView.setOnItemLongClickListener(new OnItemLongClickListener() {
		 
		    @Override 
			public boolean onItemLongClick(AdapterView parentView, View view, int position, long id) {
				topPos = position;
				final String name = ((TextView) view).getText().toString();
				final String fname = dbs.get(name); // full path name in HashMap dbs

				LayoutInflater inflater = getLayoutInflater();
				final ArrayList<String> list = new ArrayList<String>();
				for (int i = 0; i < menu_array.length; ++i) {
					list.add(menu_array[i]);
				}
				
				AlertDialog.Builder builder = new AlertDialog.Builder(c);
				final ArrayAdapter adapter = new ArrayAdapter(c, R.layout.pra_list_item, list);
				builder.setView(inflater.inflate(R.layout.list_context_menu, null))
					.setAdapter(adapter, new DialogInterface.OnClickListener() {
					@Override
					public void onClick(DialogInterface dialog, int which) {
						String result = (String) adapter.getItem(which);
						if (result.matches("Rename")){

							final Dialog dialog3 = new Dialog(BoilerPlate.this);
							dialog3.requestWindowFeature(Window.FEATURE_NO_TITLE);
							dialog3.setContentView(R.layout.alert_two_edit);
							TextView t = (TextView) dialog3.findViewById(R.id.dTitle);
							t.setText("Rename File");
							TextView m = (TextView) dialog3.findViewById(R.id.dMessage);
							m.setText("One word name. Letters only. No extension (.mp3).");
							final EditText e = (EditText) dialog3.findViewById(R.id.dEdit);
							e.setInputType(InputType.TYPE_CLASS_TEXT);
							String handle = name.replace(".mp3", "");
							e.setText(handle);
							final String o  = name;
							Button pos = (Button) dialog3.findViewById(R.id.dPos);
							pos.setText("Rename");
							pos.setOnClickListener(new OnClickListener() {
								@Override
								public void onClick(View v) {
									String newName = e.getText().toString();
									fhandler.move(fname, this_app_dir +"/"+newName+".mp3");
									dialog3.dismiss();
									onResume();
								}
								});
			
							Button neg = (Button) dialog3.findViewById(R.id.dNeg);
							neg.setText("Cancel");
							neg.setOnClickListener(new OnClickListener() {
								@Override
								public void onClick(View v) {
									dialog3.dismiss();
								}
								});
							
							dialog3.show();
						} else if (result.matches("ID3 Tag")){
							Intent tagIntent = new Intent(c, MP3Tagger.class);
							tagIntent.putExtra("FNAME", fname);
							startActivity(tagIntent);
						} else if (result.matches("Upload")){
							Uri uri = Uri.parse("file://"+ fname);
							String type = "audio/mpeg";
							Intent sharingIntent = new Intent(Intent.ACTION_SEND);
							sharingIntent.setClassName("BPpath.filebroom",
													   "BPpath.filebroom.FileBroom");
							sharingIntent.putExtra(Intent.EXTRA_STREAM, uri);
							sharingIntent.setDataAndType(uri, type);
							try{
								startActivity(sharingIntent);
							} catch (Exception e){
								toaster("FileBroom not installed", Toast.LENGTH_SHORT);
							}
						} else if (result.matches("Play")){
							Intent intent = new Intent();  
							intent.setAction(android.content.Intent.ACTION_VIEW);  
							File file = new File(fname);  
							intent.setDataAndType(Uri.fromFile(file), "audio/*");  
							startActivity(intent);

						} else if (result.matches("Delete")){
							final Dialog dialog2 = new Dialog(BoilerPlate.this);
							dialog2.requestWindowFeature(Window.FEATURE_NO_TITLE);
							dialog2.setContentView(R.layout.alert_two);
							TextView t = (TextView) dialog2.findViewById(R.id.dTitle);
							t.setText("File Deletion");
							TextView m = (TextView) dialog2.findViewById(R.id.dMessage);
							m.setText("Remove "+name+"?");
		
							Button pos = (Button) dialog2.findViewById(R.id.dPos);
							pos.setText("Delete");
							pos.setOnClickListener(new OnClickListener() {
								@Override
								public void onClick(View v) {
									fhandler.removeExt(fname);
									dialog2.dismiss();
									onResume();
								}
								});
		
							Button neg = (Button) dialog2.findViewById(R.id.dNeg);
							neg.setText("Cancel");
							neg.setOnClickListener(new OnClickListener() {
								@Override
								public void onClick(View v) {
									dialog2.dismiss();
								}
								});
							
							dialog2.show();
						}
						onResume();
							
						}
						})
					.create()
					.show();
				return true;
			}
			});

		getListView().post(new Runnable() {
				@Override
					public void run() {
					getListView().smoothScrollToPosition(topPos);
				}
			});
	}

	private String[] buildList() {
		File adp = new File(this_app_dir);
		File[] files = adp.listFiles();
		dbs  = new HashMap<String, String>();
		List<String> alist = new ArrayList<String>();
		for (File inFile : files) {
				String fname = inFile.toString();
				if (fname.endsWith(".mp3")){
					String tmp = fname;
					fname = fname.replace(this_app_dir+"/", "");
					alist.add(fname);
					dbs.put(fname, tmp);
				}
		}
		if (!newTrack.equals("")){
			alist.add(newTrack);
			dbs.put(newTrack, this_app_dir+"/"+newTrack);
			newTrack = "";
		}

		Collections.sort(alist);
		alist.add("New Track");
		dbs.put("New Track", "_new_");
		String[] list = new String[alist.size()];
		alist.toArray(list);
		return list;
	}

	public void record(String name){
		mRecMicToMp3 = new RecMicToMp3(this_app_dir+"/"+name, 32000);        
		mRecMicToMp3.setHandle(new Handler() {
			@Override
			public void handleMessage(Message msg) {
				switch (msg.what) {
				case RecMicToMp3.MSG_REC_STARTED:
					toaster("Recording Started :: Press Any Track To Stop", Toast.LENGTH_LONG);
					break;
				case RecMicToMp3.MSG_REC_STOPPED:
					toaster("Recording Stopped", Toast.LENGTH_LONG);
					break;
				case RecMicToMp3.MSG_ERROR_GET_MIN_BUFFERSIZE:
					toaster("Buffersize error", Toast.LENGTH_LONG);
					break;
				case RecMicToMp3.MSG_ERROR_CREATE_FILE:
					toaster( "File creation error", Toast.LENGTH_LONG);
					recording = false;
					break;
				case RecMicToMp3.MSG_ERROR_REC_START:
					toaster( "Recording start error", Toast.LENGTH_LONG);
					break;
				case RecMicToMp3.MSG_ERROR_AUDIO_RECORD:
					toaster( "Audio recording error", Toast.LENGTH_LONG);
					break;
				case RecMicToMp3.MSG_ERROR_AUDIO_ENCODE:
					toaster( "Audio encoding error", Toast.LENGTH_LONG);
					break;
				case RecMicToMp3.MSG_ERROR_WRITE_FILE:
					toaster( "File write error", Toast.LENGTH_LONG);
					break;
				case RecMicToMp3.MSG_ERROR_CLOSE_FILE:
					toaster( "File close error", Toast.LENGTH_LONG);
					break;
				default:
					break;
				}
			}
		});
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		if (mRecMicToMp3 != null){ 
			recording = false;
			mRecMicToMp3.stop();
			mRecMicToMp3 = null;
		}
	}

    public void prepSdcardAppDir(){
		File sdCard = Environment.getExternalStorageDirectory();
		this_app_dir = sdCard.getAbsolutePath() +"/MP3Recorder";
		File dir = new File(this_app_dir);
		dir.mkdir();
	}

	public void toaster(String text, int length) {
		Toast t = Toast.makeText(this, Html.fromHtml("<h1>"+text+"</h1>"), length);
		t.setGravity(Gravity.CENTER, 0, 0);
		t.show();
	}


	private boolean doubleBackPressedOnce = false;

	@Override
	public void onBackPressed() {
		if (doubleBackPressedOnce) {
			super.onBackPressed();
			return;
		}
		topPos = 0;
		doubleBackPressedOnce = true;
		Toast.makeText(this, R.string.exit_bkbtn, Toast.LENGTH_SHORT).show();
		new Handler().postDelayed(new Runnable() {

			@Override
			public void run() {
				doubleBackPressedOnce = false;
			}
		}, 2000);
	}

	// pride injection
	private void triggerMP3Tagger(){
		Intent intent = new Intent(this, MP3Tagger.class);
		startActivity(intent);
	}

}
